<template>
  <div data-app>
    <v-tooltip
      v-model="showTooltip"
      bottom
    >
      <template v-slot:activator="{ attrs }">
        <v-text-field
          v-bind="{ ...attrs, ...$attrs }"
          :label="label"
          prepend-inner-icon="mdi-lock"
          type="password"
          v-on="$listeners"
          @paste.prevent="onPastePasswordConfirm"
        />
      </template>
      <span>{{ $t('cannotPasteNotice') }}</span>
    </v-tooltip>
  </div>
</template>

<script>
  export default {
    name: 'PasswordConfirmationField',
    props: {
      requiredPasswordConfirmation: {
        type: Boolean,
        required: false,
        default: false,
      },
      newPassword: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        showTooltip: false,
      }
    },
    computed: {
      label () {
        const required = { required: this.requiredPasswordConfirmation ? '*' : '' }
        return this.newPassword
          ? this.$t('newPasswordConfirmation', required)
          : this.$t('passwordConfirmation', required)
      },
    },
    methods: {
      onPastePasswordConfirm () {
        this.showTooltip = true
        setTimeout(() => {
          this.showTooltip = false
        }, 3000)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          passwordConfirmation: 'Confirme a senha{required}',
          newPasswordConfirmation: 'Confirme a nova senha{required}',
          cannotPasteNotice: 'Você não pode "copiar e colar" neste campo.',
        },
        'en-US': {
          passwordConfirmation: 'Password confirmation{required}',
          newPasswordConfirmation: 'New password confirmation{required}',
          cannotPasteNotice: 'You cannot "copy and paste" on this field.',
        },
      },
    },
  }
</script>
